#INCLUDE "dcdialog.CH"
#INCLUDE "appevent.CH"

FUNCTION Main()

/*
This example shows how to create an array editor using
cell-editing.   This is a database structure array editor.
*/


LOCAL oBrowse, aStructure, aFields, GetList := {}, ;
      oToolBar, GetOptions, aOldStruct, lOk, nPointer, ;
      aField, xNIL := NIL, aTypes, aData, lEditing := .f.

USE c:\expd20\data\collect VIA 'DBFNTX'
aStructure := dbstruct()
aOldStruct := AClone(aStructure)
aFields := ARRAY(LEN(aStructure))
aFields := aStructure[1]

FOR nPointer := 1 TO Len(aStructure)
   aStructure[nPointer,1] := Pad(aStructure[nPointer,1],10)
NEXT
nPointer := 1

@ .1,.5 DCBROWSE oBrowse DATA aStructure ;
        SIZE 43,14.1 ;
        FIT ;
        PRESENTATION DC_BrowPres() ;
        NOHORIZSCROLL ;
        EDIT xbeBRW_ItemSelected ;
           MODE DCGUI_BROWSE_EDITACROSSDOWN ;
           ACTION {||lEditing:=.t.,DC_GetRefresh(GetList)} ;
           EXIT {||lEditing:=.f., ;
                  _XSample49(11,aStructure,oBrowse,nPointer,,GetList), ;
                  DC_GetRefresh(GetList)} ;
        INTO aField ;
        POINTER nPointer ;
        DELETE xbeK_DEL ;
        INSERT xbeK_INS ;
           ACTION {||lEditing := .t.,DC_GetRefresh(GetList)} ;
           DEFAULT { Space(10), Space(1), 0, 0 } ;
           EXIT {||lEditing := .f., ;
                   _XSample49(11,aStructure,oBrowse,nPointer,,GetList), ;
                   DC_GetRefresh(GetList),DC_ClearEvents()} ;
           APPEND xbeK_ALT_A ;
        EVAL {|o|o:hitBottomBlock := {||PostAppEvent(xbeP_Keyboard,xbeK_ALT_A,,oBrowse)} }

DCBROWSECOL ELEMENT 1 WIDTH 10 HEADER "Name" PARENT oBrowse ;
   EDITOR 'NAME' ;
   ID 'NAME_COLUMN'

DCBROWSECOL ELEMENT 2 WIDTH 5 HEADER "Type" PARENT oBrowse ;
   EDITOR 'TYPE'

DCBROWSECOL ELEMENT 3 WIDTH 5 HEADER "Length" PARENT oBrowse ;
   EDITOR 'LENGTH' ;
   PROTECT {|o|!_XSample49(7,aStructure,oBrowse,nPointer)}

DCBROWSECOL ELEMENT 4 WIDTH 5 HEADER "Decimals" PARENT oBrowse ;
   EDITOR 'DECIMALS' ;
   PROTECT {|o|!_XSample49(8,aStructure,oBrowse,nPointer)}

@ NIL,NIL DCGET xNIL PICT "@!" GETID 'NAME'  ;
          VALID {|o|_XSample49(1,aStructure,oBrowse,nPointer)}

aTypes := {{'C'},{'N'},{'D'},{'M'},{'L'}}
@ NIL,NIL DCGET xNIL PICTURE '@!' ;
          COMBO DATA aTypes HEIGHT 100 ELEMENT 1 ;
          ID 'TYPE' ;
          VALID {|o|_XSample49(2,aStructure,oBrowse,nPointer)}

@ NIL,NIL DCGET xNIL PICT "999" GETID 'LENGTH' ;
          VALID {|o|_XSample49(3,aStructure,oBrowse,nPointer)}

@ NIL,NIL DCGET xNIL PICT "999"  GETID 'DECIMALS' ;
          VALID {|o|_XSample49(4,aStructure,oBrowse,nPointer)} ;
          WHEN {|o|_XSample49(8,aStructure,oBrowse,nPointer)}

@ 15,1 DCTOOLBAR oToolBar SIZE 45,1.2 BUTTONSIZE 9,1.2

DCADDBUTTON CAPTION '&Insert' PARENT oToolBar ;
   TOOLTIP 'Add New Field' ;
   ACCELKEY xbeK_ALT_I ;
   WHEN {||!lEditing} ;
   ACTION {||SetAppFocus(DC_GetObject(GetList,'NAME_COLUMN')), ;
             PostAppEvent(xbeP_Keyboard,xbeK_INS,,oBrowse)}

DCADDBUTTON CAPTION '&Delete' PARENT oToolBar ;
   TOOLTIP 'Delete Field' ;
   ACCELKEY xbeK_ALT_D ;
   WHEN {||!lEditing} ;
   ACTION {||PostAppEvent(xbeP_Keyboard,xbeK_DEL,,oBrowse), ;
             SetAppFocus(DC_GetObject(GetList,'NAME_COLUMN'))}

DCADDBUTTON CAPTION '&Replicate' PARENT oToolBar ;
   TOOLTIP 'Replicate a Group of Fields' ;
   ACCELKEY xbeK_ALT_R ;
   WHEN {||!lEditing} ;
   ACTION {||_XSample49(5,aStructure,oBrowse,nPointer)}

DCADDBUTTON CAPTION '&Ok' PARENT oToolBar ;
   TOOLTIP 'Exit and Save Changes' ;
   ACCELKEY xbeK_ALT_O ;
   WHEN {||!lEditing} ;
   ACTION {||_XSample49(9,,,,,GetList)}

DCADDBUTTON CAPTION '&Cancel' PARENT oToolBar ;
   TOOLTIP 'Exit and Abort Changes' ;
   ACCELKEY xbeK_ALT_C ;
   WHEN {||!lEditing} ;
   ACTION {||_XSample49(10,,,,,GetList)}

DCGETOPTIONS ABORTQUERY

DCREAD GUI FIT TITLE "Database Structure Editor";
   OPTIONS GetOptions ;
   MODAL ;
   TO lOk ;
   SETFOCUS 'NAME_COLUMN' ;
   SETAPPWINDOW

RETURN IIF( lOk, aStructure, aOldStruct )

/* ------------------- */

STATIC FUNCTION _XSample49( nAction, aStructure, oBrowse, ;
                            nPointer, xValue, aGetList )

LOCAL nFound, GetList := {}, GetOptions, ;
      nVarLength, nNumStart, nNumEnd, nVarPointer, cNewString, ;
      cFieldName, cFieldType, nFieldLen, nFieldDec, nFieldNmbr, lOk, ;
      nFieldCount, cVarName, cVar, i

IF nAction < 9
  IF nPointer > Len(aStructure)
    nPointer := Len(aStructure)
  ENDIF
  cFieldName := aStructure[nPointer,1]
  cFieldType := aStructure[nPointer,2]
  nFieldLen  := aStructure[nPointer,3]
  nFieldDec  := aStructure[nPointer,4]
ENDIF

IF nAction = 1 // Validate field name

  nFound := 0
  FOR i := 1 TO LEN(aStructure)
    IF ALLTRIM(Upper(aStructure[i,1]))==ALLTRIM(Upper(cFieldName)) .AND. i # nPointer
      nFound := i
      EXIT
    ENDIF
  NEXT

  IF Empty(cFieldName)
     DC_WinAlert('Field name cannot be empty')
     RETURN .f.
  ELSEIF nFound # 0 .AND. nFound # nPointer
     DC_WinAlert('Duplicate Field Name.  Please re-enter')
     RETURN .f.
  ENDIF

ELSEIF nAction = 2 // Validate field type

   IF !(cFieldType $ 'cClLmMnNdD')
      DCMSGBOX 'Valid Field types are:', ;
               '', ;
               'C - Character', ;
               'N - Numeric', ;
               'D - Date', ;
               'L - Logical', ;
               'M - Memo' ;
      TITLE 'Field Type Error'
      RETURN .f.
   ENDIF

ELSEIF nAction = 3 // Validate field Length

  IF nFieldLen <= 0
     DC_WinAlert('Length cannot be less than 1')
     RETURN .f.
  ENDIF

ELSEIF nAction = 4 // Validate field decimals

  IF cFieldType $ 'cCdDlLmM'
    aStructure[nPointer,4] := 0
  ELSEIF nFieldDec > nFieldLen - 2
     DC_WinAlert('Decimals cannot be greater than ' + ;
                  Str(nFieldLen-2))
     RETURN .f.
  ENDIF
ELSEIF nAction = 5 // Replicate a set of fields

  cFieldName := SPACE(10)
  nFieldNmbr := 0
  cFieldType := ' '
  nFieldLen := 1
  nFieldDec := 0
  @ 1,0 DCSAY 'This dialog will create a set of new fields with an automatic'
  @ 2,0 DCSAY 'Incrementation of any imbedded number string in the field name.'
  @ 3,0 DCSAY '  Caution: If replicating 10-99 fields, use 1 leading zero'
  @ 4,0 DCSAY '  on start number.  Ex: NMBR_01_A'
  @ 5,0 DCSAY '  If replicating 100-999 fields, use 2 leading zeros'
  @ 6,0 DCSAY '  on start number.  Ex: TRANS_001'

  @ 8,0 DCSAY 'Field Name' GET cFieldName PICT '@!' ;
        VALID {||_XSample49(1,aStructure,oBrowse,nPointer,cFieldName)} ;
        SAYSIZE 25
  @ 9,0 DCSAY 'Field Type' GET cFieldType PICT '@!' ;
        VALID {||_XSample49(2,aStructure,oBrowse,nPointer,cFieldType)} ;
        SAYSIZE 25
  @10,0 DCSAY 'Field Length' GET nFieldLen PICT '999999' ;
        VALID {||_XSample49(3,aStructure,oBrowse,nPointer,nFieldLen)} ;
        SAYSIZE 25
  @11,0 DCSAY 'Field Decimals' GET nFieldDec PICT '99' ;
        VALID {||_XSample49(4,aStructure,oBrowse,nPointer,nFieldDec)} ;
        SAYSIZE 25
  @13,8 DCSAY 'Number of Fields to Replicate' GET nFieldNmbr PICT '999' ;
        SAYSIZE 25

  DCGETOPTIONS SAYRIGHTJUST SAYWIDTH 350
  DCREAD GUI FIT ADDBUTTONS TO lOk OPTIONS GetOptions MODAL ;
     TITLE 'Replicate a Group of Fields'

  IF lOk .AND. !Empty(cFieldName) .AND. !Empty(cFieldType) ;
      .AND. !Empty(nFieldLen)
    FOR nFieldCount := 1 TO nFieldNmbr
       AADD( aStructure,;
            { cFieldName, cFieldType, nFieldLen, nFieldDec, cFieldName } )
       cFieldName := _XSample49(6,aStructure,oBrowse,nPointer,cFieldName)
    NEXT
    oBrowse:refreshAll()
  ENDIF

ELSEIF nAction = 6 // Increment a numeric value within a string

  cVarName := xValue
  nVarLength := LEN(cVarName)
  nVarPointer := nVarLength
  DO WHILE nVarPointer>0
    IF SUBSTR(cVarName,nVarPointer,1)>='0' ;
      .AND. SUBSTR(cVarName,nVarPointer,1)<='9'
      EXIT
    ENDIF
    nVarPointer--
  ENDDO
  nNumEnd := nVarPointer
  DO WHILE nVarPointer>0
    IF (SUBSTR(cVarName,nVarPointer,1)<'0' ;
      .OR. SUBSTR(cVarName,nVarPointer,1)>'9') .AND. ;
      SUBSTR(cVarName,nVarPointer,1)#' '
      EXIT
    ENDIF
    nVarPointer--
  ENDDO
  nNumStart := nVarPointer+1
  cNewString := STRTRAN(STR(VAL(SUBSTR(cVarName,nNumStart,;
             nNumEnd-nNumStart+1))+1,nNumEnd-nNumStart+1),' ','0')
  cVar := SUBSTR(cVarName,1,nNumStart-1)+cNewString+;
          SUBSTR(cVarName,nNumEnd+1,nVarLength-nNumEnd)

  RETURN cVar

ELSEIF nAction = 7 // When test for Field Length

  IF cFieldType $ 'mMdDlL'
     RETURN .f.
  ENDIF
  RETURN .t.

ELSEIF nAction = 8 // When test for Field Decimals

  IF cFieldType $ 'mMdDlLcC'
     RETURN .f.
  ENDIF
  RETURN .t.

ELSEIF nAction = 9 // Exit and Save

  IF DC_MsgBox(,,{'Exit and Save Changes?'},,,,.t.)
    DC_ReadGuiEvent(DCGUI_EXIT_OK,aGetList)
  ENDIF
  RETURN .t.

ELSEIF nAction = 10 // Exit and Abort

  IF DC_MsgBox(,,{'Exit and Abort Changes?'},,,,.t.)
    DC_ReadGuiEvent(DCGUI_EXIT_ABORT,aGetList)
  ENDIF
  RETURN .t.

ELSEIF nAction = 11 // Test if Empty  or duplicate

  cFieldName := aStructure[nPointer,1]
  cFieldType := aStructure[nPointer,2]
  nFieldLen  := aStructure[nPointer,3]

  nFound := 0
  FOR i := 1 TO LEN(aStructure)
    IF ALLTRIM(Upper(aStructure[i,1]))==ALLTRIM(Upper(cFieldName)) .AND. i # nPointer
      nFound := i
      EXIT
    ENDIF
  NEXT

  IF (nFound # 0 .AND. nFound # nPointer ) .OR. Empty(cFieldName) .OR. ;
      Empty(cFieldType) .OR. Empty(nFieldLen)
     ADel(aStructure,nPointer)
     ASize(aStructure,Len(aStructure)-1)
     oBrowse:refreshAll()
  ENDIF

ENDIF

IF nPointer > Len(aStructure)
  nPointer := Len(aStructure)
ENDIF

aStructure[nPointer,2] := Upper(aStructure[nPointer,2])

IF cFieldType = 'C'
   aStructure[nPointer,4] := 0
ELSEIF cFieldType = 'M'
   aStructure[nPointer,3] := 10
   aStructure[nPointer,4] := 0
ELSEIF cFieldType = 'D'
   aStructure[nPointer,3] := 8
   aStructure[nPointer,4] := 0
ELSEIF cFieldType = 'L'
   aStructure[nPointer,3] := 1
   aStructure[nPointer,4] := 0
ENDIF

IF nPointer == Len(oBrowse:dataSource)
  PostAppEvent(xbeP_Keyboard,xbeK_ALT_A,,oBrowse)
ENDIF

RETURN .t.


PROC appsys ; RETURN
